"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CardTabs = CardTabs;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _designparams = require("../designparams");

var _Typography = require("../Typography");

var _excluded = ["value", "options", "onChange", "variant", "hasBackground"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var OUTSIDE_TAB_HEIGHT = _designparams.componentSize.small;
var MARKER_THICKNESS = '2px';

var TabContainer = _styledComponents.default.div.withConfig({
  displayName: "CardTabs__TabContainer",
  componentId: "sc-iicna0-0"
})(["display:flex;height:100%;"]);

var Tab = _styledComponents.default.div.withConfig({
  displayName: "CardTabs__Tab",
  componentId: "sc-iicna0-1"
})(["display:flex;align-items:center;justify-content:center;cursor:pointer;user-select:none;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;", " ", " ", ""], _ref => {
  var {
    variant,
    selected,
    theme
  } = _ref;
  return variant === 'inside' ? (0, _styledComponents.css)(["position:relative;max-width:100%;overflow:hidden;padding:0 ", ";color:", ";&:not(:first-child){margin-left:", ";}&:hover{color:", ";}"], _designparams.spacing.medium, selected ? theme.color.text01() : theme.color.text05(), _designparams.spacing.medium, selected ? undefined : theme.color.text03()) : (0, _styledComponents.css)(["background-color:", ";border-radius:", " ", " 0 0;box-shadow:", ";padding:0 ", ";height:", ";color:", ";clip-path:inset(-2px -2px 0 -2px);&:not(:first-child){margin-left:", ";}&:hover{background-color:", ";}"], selected ? theme.color.background00() : theme.color.background02(), _designparams.shape.radius.medium, _designparams.shape.radius.medium, theme.shadow.tab, _designparams.spacing.large, OUTSIDE_TAB_HEIGHT, theme.color.text01(), _designparams.spacing.medium, selected ? theme.color.background00() : theme.color.background01());
}, _ref2 => {
  var {
    disabled
  } = _ref2;
  return disabled ? (0, _styledComponents.css)(["opacity:", ";pointer-events:none;"], _designparams.opacity[48]) : undefined;
}, _ref3 => {
  var {
    hasBackground,
    selected,
    theme
  } = _ref3;
  return hasBackground && selected ? (0, _styledComponents.css)(["background-color:", ";"], theme.color.element15()) : undefined;
}); // Renders a marker indicating that the tab is selected


var TabBaseMarker = _styledComponents.default.div.withConfig({
  displayName: "CardTabs__TabBaseMarker",
  componentId: "sc-iicna0-2"
})(["content:' ';position:absolute;bottom:0;flex:none;background-color:", ";transition:all 500ms cubic-bezier(0.57,0.67,0.015,1.005);border-radius:", " ", " 0 0;", ""], _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.elementPrimary();
}, _designparams.shape.radius.small, _designparams.shape.radius.small, _ref5 => {
  var {
    selected
  } = _ref5;
  return selected ? (0, _styledComponents.css)(["height:", ";width:100%;transform:scaleX(1);"], MARKER_THICKNESS) : (0, _styledComponents.css)(["transform:scaleX(0);"]);
});

function InternalTab(_ref6) {
  var {
    id,
    selected = false,
    onClick,
    label,
    variant,
    disabled = false,
    hasBackground = false
  } = _ref6;
  var onClickHandler = (0, _react.useCallback)(() => {
    if (!selected) {
      onClick(id);
    }
  }, [selected, onClick, id]);
  return /*#__PURE__*/_react.default.createElement(Tab, {
    selected: selected,
    onClick: onClickHandler,
    disabled: disabled,
    variant: variant,
    hasBackground: hasBackground
  }, variant === 'inside' ? /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    variant: "card-title"
  }, label) : /*#__PURE__*/_react.default.createElement(_Typography.Typography, null, label), variant === 'inside' ? /*#__PURE__*/_react.default.createElement(TabBaseMarker, {
    selected: selected
  }) : undefined);
}

function CardTabs(_ref7) {
  var {
    value,
    options,
    onChange,
    variant,
    hasBackground
  } = _ref7,
      props = _objectWithoutProperties(_ref7, _excluded);

  var onClickHandler = (0, _react.useCallback)(index => onChange(options[index].value), [options, onChange]);
  return /*#__PURE__*/_react.default.createElement(TabContainer, props, options.map((_ref8, index) => {
    var {
      value: tabValue,
      label,
      disabled
    } = _ref8;
    return /*#__PURE__*/_react.default.createElement(InternalTab, {
      key: index,
      id: index,
      selected: value === tabValue,
      onClick: onClickHandler,
      label: label,
      variant: variant,
      disabled: disabled,
      hasBackground: hasBackground
    });
  }));
}