import React, { FC } from 'react';
import { ExpandableListItemType } from './ExpandableListItem';
export * from './ExpandableListItem';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = React.HTMLAttributes<BaseElement>;
interface ExpandableListProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * Used to create an array of items.
     */
    readonly items: ReadonlyArray<ExpandableListItemType>;
}
export declare const ExpandableList: FC<ExpandableListProps>;
