"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Step = exports.StepControls = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _practicalReactComponentsIcons = require("practical-react-components-icons");

var _Typography = require("../Typography");

var _Button = require("../Button");

var _theme = require("../theme");

var _designparams = require("../designparams");

var _excluded = ["children", "label", "hasErrors", "hasAnyErrors", "currentStep", "stepId", "setCurrentStep", "completedSteps", "setCompletedSteps", "numberOfSteps", "completeAction", "nextAction", "prevAction", "disableNext"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var StepWrapper = _styledComponents.default.div.withConfig({
  displayName: "Step__StepWrapper",
  componentId: "sc-18j56nc-0"
})(["font-size:", ";font-weight:", ";padding-top:", ";"], _theme.font.size.regular, _theme.font.fontWeight.normal, _designparams.spacing.extraLarge);

var StepNumber = _styledComponents.default.span.withConfig({
  displayName: "Step__StepNumber",
  componentId: "sc-18j56nc-1"
})(["align-items:center;", " border-radius:", ";color:", ";cursor:pointer;display:flex;fill:", ";font-size:", ";height:20px;justify-content:center;left:-12px;line-height:", ";position:absolute;text-align:center;top:0;width:20px;"], _ref => {
  var {
    active,
    theme,
    completed,
    hasErrors
  } = _ref;

  if (active || completed && hasErrors !== true) {
    return (0, _styledComponents.css)(["background-color:", ";"], () => theme.color.elementPrimary());
  }

  if (completed && hasErrors === true) {
    return (0, _styledComponents.css)(["background-color:", ";"], () => theme.color.elementError());
  }

  return (0, _styledComponents.css)(["background-color:", ";"], () => theme.color.element14());
}, _designparams.shape.radius.circle, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text00();
}, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.text00();
}, _theme.font.size.small, _theme.font.lineHeight.large);

var StepDivider = _styledComponents.default.span.withConfig({
  displayName: "Step__StepDivider",
  componentId: "sc-18j56nc-2"
})(["", " top:22px;width:1px;position:absolute;", " left:-2px;"], _ref4 => {
  var {
    active
  } = _ref4;
  return active ? (0, _styledComponents.css)(["height:calc(100% - 24px);"]) : (0, _styledComponents.css)(["height:8px;"]);
}, _ref5 => {
  var {
    active,
    theme,
    completed
  } = _ref5;
  return active || completed ? (0, _styledComponents.css)(["background-color:", ";"], () => theme.color.elementPrimary()) : (0, _styledComponents.css)(["background-color:", ";"], () => theme.color.element14());
});

var StepHeader = _styledComponents.default.div.withConfig({
  displayName: "Step__StepHeader",
  componentId: "sc-18j56nc-3"
})(["position:relative;margin-top:-", ";"], _designparams.spacing.large);

var StepLabel = (0, _styledComponents.default)(_Typography.Typography).withConfig({
  displayName: "Step__StepLabel",
  componentId: "sc-18j56nc-4"
})(["align-items:center;", " display:flex;min-height:24px;padding-left:18px;"], _ref6 => {
  var {
    active,
    completed,
    theme
  } = _ref6;
  return !active && !completed ? (0, _styledComponents.css)(["color:", ";"], () => theme.color.text05()) : (0, _styledComponents.css)(["font-weight:", ";"], theme.font.fontWeight.semibold);
});

var StepContentContainer = _styledComponents.default.div.withConfig({
  displayName: "Step__StepContentContainer",
  componentId: "sc-18j56nc-5"
})(["padding:", " 0 ", " 20px;"], _designparams.spacing.medium, _designparams.spacing.huge);

var StepControls = _styledComponents.default.div.withConfig({
  displayName: "Step__StepControls",
  componentId: "sc-18j56nc-6"
})(["display:inline-grid;grid-template-columns:auto auto;grid-gap:", ";padding:", " 0 20px 20px;"], _designparams.spacing.medium, _designparams.spacing.small);

exports.StepControls = StepControls;

var StepContentWrapper = _styledComponents.default.div.withConfig({
  displayName: "Step__StepContentWrapper",
  componentId: "sc-18j56nc-7"
})(["position:relative;min-height:32px;margin-bottom:-8px;"]);

var Step = _ref7 => {
  var {
    children,
    label,
    hasErrors,
    hasAnyErrors,
    currentStep,
    stepId,
    setCurrentStep,
    completedSteps,
    setCompletedSteps,
    numberOfSteps,
    completeAction,
    nextAction,
    prevAction,
    disableNext
  } = _ref7,
      props = _objectWithoutProperties(_ref7, _excluded);

  var active = currentStep === stepId;
  var completed = completedSteps.includes(stepId);
  var lastStep = stepId === numberOfSteps - 1;
  var onBackButtonClick = (0, _react.useCallback)(event => {
    var prevStep = stepId - 1;
    setCompletedSteps(completedSteps.filter(s => s !== prevStep && s !== stepId));
    setCurrentStep(prevStep);

    if (prevAction.onClick !== undefined) {
      prevAction.onClick(event);
    }
  }, [completedSteps, prevAction, setCompletedSteps, setCurrentStep, stepId]);
  var onNextButtonClick = (0, _react.useCallback)(event => {
    setCompletedSteps([...completedSteps, stepId]);
    setCurrentStep(stepId + 1);

    if (nextAction.onClick !== undefined) {
      nextAction.onClick(event);
    }
  }, [completedSteps, nextAction, setCompletedSteps, setCurrentStep, stepId]);
  var onCompleteButtonClick = (0, _react.useCallback)(event => {
    setCompletedSteps(Array.from(Array(numberOfSteps).keys()));

    if (!hasAnyErrors) {
      setCurrentStep(-1);
    }

    if (completeAction.onClick !== undefined) {
      completeAction.onClick(event);
    }
  }, [setCompletedSteps, numberOfSteps, hasAnyErrors, completeAction, setCurrentStep]);
  var onStepNumberClick = (0, _react.useCallback)(() => setCurrentStep(stepId), [setCurrentStep, stepId]);
  return /*#__PURE__*/_react.default.createElement(StepWrapper, props, /*#__PURE__*/_react.default.createElement(StepHeader, null, /*#__PURE__*/_react.default.createElement(StepNumber, {
    active: active,
    completed: completed,
    hasErrors: hasErrors,
    onClick: onStepNumberClick
  }, completed && hasErrors !== true ? /*#__PURE__*/_react.default.createElement(_practicalReactComponentsIcons.CheckIcon, null) : null, completed && hasErrors === true ? /*#__PURE__*/_react.default.createElement(_practicalReactComponentsIcons.WarningIcon, null) : null, !completed ? /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    variant: "default-text"
  }, stepId + 1) : null)), /*#__PURE__*/_react.default.createElement(StepContentWrapper, {
    lastStep: lastStep
  }, lastStep ? null : /*#__PURE__*/_react.default.createElement(StepDivider, {
    active: active,
    completed: completed
  }), /*#__PURE__*/_react.default.createElement(StepLabel, {
    variant: "default-text",
    active: active,
    completed: completed
  }, label), active ? /*#__PURE__*/_react.default.createElement(StepContentContainer, null, children) : null, active ? /*#__PURE__*/_react.default.createElement(StepControls, null, currentStep > 0 ? /*#__PURE__*/_react.default.createElement(_Button.Button, {
    onClick: onBackButtonClick,
    variant: "secondary",
    label: prevAction.label
  }) : null, lastStep ? null : /*#__PURE__*/_react.default.createElement(_Button.Button, {
    onClick: onNextButtonClick,
    label: nextAction.label,
    disabled: disableNext
  }), lastStep ? /*#__PURE__*/_react.default.createElement(_Button.Button, {
    onClick: onCompleteButtonClick,
    label: completeAction.label
  }) : null) : null));
};

exports.Step = Step;