"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "StepContent", {
  enumerable: true,
  get: function get() {
    return _Step.StepContent;
  }
});
Object.defineProperty(exports, "StepperAction", {
  enumerable: true,
  get: function get() {
    return _Step.StepperAction;
  }
});
exports.Stepper = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _designparams = require("../designparams");

var _Button = require("../Button");

var _Paper = require("../Paper");

var _Step = require("./Step");

var _excluded = ["steps", "completeAction", "prevAction", "nextAction", "resetAction"],
    _excluded2 = ["content"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var StepperWrapper = (0, _styledComponents.default)(_Paper.Paper).withConfig({
  displayName: "Stepper__StepperWrapper",
  componentId: "sc-10vmwq8-0"
})(["padding:", " ", " ", " 36px;box-shadow:none;"], _designparams.spacing.large, _designparams.spacing.extraLarge, _designparams.spacing.large);

var Stepper = _ref => {
  var {
    steps,
    completeAction,
    prevAction,
    nextAction,
    resetAction
  } = _ref,
      props = _objectWithoutProperties(_ref, _excluded);

  var [currentStep, setCurrentStep] = (0, _react.useState)(0);
  var [completedSteps, setCompletedSteps] = (0, _react.useState)([]);
  var hasAnyErrors = (0, _react.useMemo)(() => steps.some(_ref2 => {
    var {
      hasErrors
    } = _ref2;
    return hasErrors === true;
  }), [steps]);
  var onResetButtonClick = (0, _react.useCallback)(event => {
    setCompletedSteps([]);
    setCurrentStep(0);

    if (resetAction.onClick !== undefined) {
      resetAction.onClick(event);
    }
  }, [resetAction]);
  return /*#__PURE__*/_react.default.createElement(StepperWrapper, _extends({
    square: true
  }, props), steps.map((_ref3, index) => {
    var {
      content
    } = _ref3,
        rest = _objectWithoutProperties(_ref3, _excluded2);

    return /*#__PURE__*/_react.default.createElement(_Step.Step, _extends({
      key: index,
      hasAnyErrors: hasAnyErrors,
      currentStep: currentStep,
      numberOfSteps: steps.length,
      stepId: index,
      setCurrentStep: setCurrentStep,
      completedSteps: completedSteps,
      setCompletedSteps: setCompletedSteps,
      completeAction: completeAction,
      prevAction: prevAction,
      nextAction: nextAction,
      resetAction: resetAction
    }, rest), content);
  }), currentStep === -1 ? /*#__PURE__*/_react.default.createElement(_Step.StepControls, null, /*#__PURE__*/_react.default.createElement(_Button.Button, {
    onClick: onResetButtonClick,
    variant: "secondary",
    label: resetAction.label
  })) : null);
};

exports.Stepper = Stepper;