"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseToast = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _practicalReactComponentsIcons = require("practical-react-components-icons");

var _designparams = require("../designparams");

var _Icon = require("../Icon");

var _excluded = ["toastId", "dismissToast", "icon", "label", "message", "onClose", "duration", "hasCloseButton", "zIndex"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Building blocks
 */
var IconWrapper = _styledComponents.default.div.withConfig({
  displayName: "Toast__IconWrapper",
  componentId: "sc-ut6xlh-0"
})(["height:", ";width:", ";display:flex;align-items:center;justify-content:center;"], _designparams.iconSize.medium, _designparams.iconSize.medium);

var CloseIconWrapper = (0, _styledComponents.default)(IconWrapper).withConfig({
  displayName: "Toast__CloseIconWrapper",
  componentId: "sc-ut6xlh-1"
})(["cursor:pointer;color:", ";height:", ";width:", ";border-radius:", ";transition:all 640ms;&:hover{color:", ";background-color:", ";}"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.element11();
}, _designparams.componentSize.small, _designparams.componentSize.small, _designparams.shape.radius.circle, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text04();
}, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.element11(_designparams.opacity[16]);
});

var IconContainer = _styledComponents.default.div.withConfig({
  displayName: "Toast__IconContainer",
  componentId: "sc-ut6xlh-2"
})(["height:", ";width:", ";display:flex;align-items:center;justify-content:center;border-right:solid 1px ", ";"], _designparams.componentSize.extraLarge, _designparams.componentSize.extraLarge, _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.background01();
});

var CloseIconContainer = (0, _styledComponents.default)(IconContainer).withConfig({
  displayName: "Toast__CloseIconContainer",
  componentId: "sc-ut6xlh-3"
})(["border:none;"]);

var LabelContainer = _styledComponents.default.div.withConfig({
  displayName: "Toast__LabelContainer",
  componentId: "sc-ut6xlh-4"
})(["display:flex;flex-direction:column;justify-content:flex-start;overflow:hidden;text-overflow:ellipsis;"]);

var MessageContainer = _styledComponents.default.div.withConfig({
  displayName: "Toast__MessageContainer",
  componentId: "sc-ut6xlh-5"
})(["grid-column:-1 / 1;padding:", ";border-top:solid 1px ", ";color:", ";"], _designparams.spacing.large, _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.color.background01();
}, _ref6 => {
  var {
    theme
  } = _ref6;
  return theme.color.text01();
});

var ToastWrapper = _styledComponents.default.div.attrs(_ref7 => {
  var {
    zIndex
  } = _ref7;
  return {
    style: {
      zIndex
    }
  };
}).withConfig({
  displayName: "Toast__ToastWrapper",
  componentId: "sc-ut6xlh-6"
})(["position:relative;align-items:center;background-color:", ";box-shadow:", ";border-radius:", ";display:grid;grid-template-columns:", ";grid-template-rows:", ";margin-top:", ";will-change:transform;transition:all 320ms ease-in-out;&.practical-enter{opacity:0;transform:translateY(-150%);}&.practical-enter-active{opacity:1;transform:translateY(0);}&.practical-enter-done{opacity:1;transform:translateY(0);}&.practical-exit{opacity:1;transform:translateY(0);}&.practical-exit-active{opacity:0;transform:translateY(-150%);}&.practical-exit-done{opacity:0;transform:translateY(-150%);}"], _ref8 => {
  var {
    theme
  } = _ref8;
  return theme.color.background00();
}, _ref9 => {
  var {
    theme
  } = _ref9;
  return theme.shadow.toast;
}, _designparams.shape.radius.medium, _ref10 => {
  var {
    hasClose
  } = _ref10;
  return hasClose ? 'auto 1fr auto' : 'auto 1fr';
}, _ref11 => {
  var {
    hasMessage
  } = _ref11;
  return hasMessage ? '1fr auto' : '1fr';
}, _designparams.spacing.large);
/*
 * BaseToast
 */


/**
 * A basic container for all kinds of toasts.
 * Child elements are passed as props.
 */
var BaseToast = /*#__PURE__*/_react.default.memo( /*#__PURE__*/_react.default.forwardRef((_ref12, ref) => {
  var {
    toastId,
    dismissToast,
    icon,
    label,
    message,
    onClose,
    duration,
    hasCloseButton = true,
    zIndex
  } = _ref12,
      props = _objectWithoutProperties(_ref12, _excluded);

  var onDismissToast = (0, _react.useCallback)(() => {
    dismissToast(toastId);

    if (onClose !== undefined) {
      onClose(toastId);
    }
  }, [toastId, onClose, dismissToast]);
  (0, _react.useEffect)(() => {
    if (duration !== undefined) {
      var autoDismissTimer = setTimeout(onDismissToast, duration);
      return () => {
        clearTimeout(autoDismissTimer);
      };
    }
  }, [duration, onDismissToast, toastId, label, message]);
  return /*#__PURE__*/_react.default.createElement(ToastWrapper, _extends({
    hasMessage: message !== undefined,
    hasClose: hasCloseButton,
    zIndex: zIndex
  }, props, {
    ref: ref
  }), /*#__PURE__*/_react.default.createElement(IconContainer, null, icon), /*#__PURE__*/_react.default.createElement(LabelContainer, null, label), hasCloseButton ? /*#__PURE__*/_react.default.createElement(CloseIconContainer, null, /*#__PURE__*/_react.default.createElement(CloseIconWrapper, {
    onClick: onDismissToast
  }, /*#__PURE__*/_react.default.createElement(_Icon.Icon, {
    icon: _practicalReactComponentsIcons.CloseIcon
  }))) : null, message !== undefined ? /*#__PURE__*/_react.default.createElement(MessageContainer, null, message) : null);
}));

exports.BaseToast = BaseToast;
BaseToast.displayName = 'BaseToast';