"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tooltip = exports.ExpandedTooltipTypography = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _reactHooksShareable = require("react-hooks-shareable");

var _Typography = require("../Typography");

var _PopOver = require("../PopOver");

var _designparams = require("../designparams");

var _theme = require("../theme");

var _excluded = ["children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Tooltip
 *
 * A small info shown on hover.
 * Positioned below the anchor element,
 * aliigned to it's center.
 */
var BaseTooltipWrapper = _styledComponents.default.div.withConfig({
  displayName: "Tooltip__BaseTooltipWrapper",
  componentId: "sc-uw6km6-0"
})(["display:flex;max-width:280px;border-radius:", ";> *{white-space:pre-line;}"], _designparams.shape.radius.small);

var TooltipWrapper = (0, _styledComponents.default)(BaseTooltipWrapper).withConfig({
  displayName: "Tooltip__TooltipWrapper",
  componentId: "sc-uw6km6-1"
})(["align-items:center;margin-top:", ";padding:", " ", ";min-height:", ";color:", ";background-color:", ";"], _designparams.spacing.small, _designparams.spacing.small, _designparams.spacing.medium, _designparams.componentSize.mini, _ref => {
  var {
    theme
  } = _ref;
  return theme.color.background00();
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text04();
});
var ExpandedTooltipWrapper = (0, _styledComponents.default)(BaseTooltipWrapper).withConfig({
  displayName: "Tooltip__ExpandedTooltipWrapper",
  componentId: "sc-uw6km6-2"
})(["flex-direction:column;align-items:flex-start;margin:", " ", ";padding:", ";height:auto;color:", ";background-color:", ";box-shadow:", ";word-break:break-word;animation:fadein 200ms ease-out;@keyframes fadein{from{opacity:0;}to{opacity:1;}}"], _designparams.spacing.medium, _designparams.spacing.small, _designparams.spacing.medium, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.text01();
}, _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.background00();
}, _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.shadow.tooltip;
});

var ExpandedTooltipTop = _styledComponents.default.div.withConfig({
  displayName: "Tooltip__ExpandedTooltipTop",
  componentId: "sc-uw6km6-3"
})(["display:flex;align-items:center;justify-content:space-between;width:100%;white-space:nowrap;"]);

var ExpandedTooltipTitle = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'chip-tag-text'
}).withConfig({
  displayName: "Tooltip__ExpandedTooltipTitle",
  componentId: "sc-uw6km6-4"
})(["font-weight:", ";margin-bottom:", ";"], _theme.font.fontWeight.semibold, _designparams.spacing.medium);
var ExpandedTooltipExtraInfo = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'compact-label'
}).withConfig({
  displayName: "Tooltip__ExpandedTooltipExtraInfo",
  componentId: "sc-uw6km6-5"
})(["margin-bottom:", ";"], _designparams.spacing.medium);
var StyledExpandedTooltipTypography = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'chip-tag-text'
}).withConfig({
  displayName: "Tooltip__StyledExpandedTooltipTypography",
  componentId: "sc-uw6km6-6"
})(["white-space:normal;"]);

var ExpandedTooltipTypography = _ref6 => {
  var {
    children
  } = _ref6;
  return /*#__PURE__*/_react.default.createElement(StyledExpandedTooltipTypography, null, children);
};

exports.ExpandedTooltipTypography = ExpandedTooltipTypography;

var ToolTipUpArrow = _styledComponents.default.div.withConfig({
  displayName: "Tooltip__ToolTipUpArrow",
  componentId: "sc-uw6km6-7"
})(["width:0;height:0;margin:3px ", " 0 ", ";border-left:5px solid transparent;border-right:5px solid transparent;border-bottom:5px solid ", ";"], _designparams.spacing.medium, _designparams.spacing.medium, _ref7 => {
  var {
    theme
  } = _ref7;
  return theme.color.background00();
});

var ToolTipDownArrow = _styledComponents.default.div.withConfig({
  displayName: "Tooltip__ToolTipDownArrow",
  componentId: "sc-uw6km6-8"
})(["width:0;height:0;margin:0 ", " 3px ", ";border-left:5px solid transparent;border-right:5px solid transparent;border-top:5px solid ", ";"], _designparams.spacing.medium, _designparams.spacing.medium, _ref8 => {
  var {
    theme
  } = _ref8;
  return theme.color.background00();
});

var Tooltip = _ref9 => {
  var {
    children
  } = _ref9,
      props = _objectWithoutProperties(_ref9, _excluded);

  var child = _react.Children.only(children);

  var [anchorEl, setAnchorEl] = (0, _react.useState)(null);
  var [visible, show, hide] = (0, _reactHooksShareable.useBoolean)(false);
  var [debouncedVisible, setDebouncedVisible] = (0, _react.useState)(visible);
  var [hasOverflow, setHasOverflow] = (0, _react.useState)(false);
  var [horizontalLayout, setHorizontalLayout] = (0, _react.useState)('center');
  var [tooltipEl, setTooltipEl] = (0, _react.useState)(null);
  (0, _react.useEffect)(() => {
    var delayVisible = () => setDebouncedVisible(visible);

    var delayed = setTimeout(delayVisible, 250);
    return () => {
      clearTimeout(delayed);
    };
  }, [visible]);
  (0, _react.useLayoutEffect)(() => {
    if (anchorEl === null) {
      return;
    }

    anchorEl.addEventListener('pointerover', show);
    anchorEl.addEventListener('pointerout', hide);
    return () => {
      anchorEl.removeEventListener('pointerover', show);
      anchorEl.removeEventListener('pointerout', hide);
    };
  }, [anchorEl, hide, show]);
  (0, _react.useLayoutEffect)(() => {
    if (tooltipEl === null || anchorEl === null) {
      return;
    }

    var {
      bottom
    } = anchorEl.getBoundingClientRect();
    var bottomSpace = document.documentElement.clientHeight - bottom; // See if `bottomSpace` is smaller than Tooltip height.
    // "8" is margin of the TooltipWrapper.

    setHasOverflow(tooltipEl.clientHeight + 8 > bottomSpace);
    var {
      left,
      right
    } = tooltipEl.getBoundingClientRect();

    if (left < 0) {
      setHorizontalLayout('left');
    } else if (right > document.documentElement.clientWidth) {
      setHorizontalLayout('right');
    }
  }, [anchorEl, tooltipEl]);

  if (props.variant !== 'expanded') {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.cloneElement(child, {
      ref: setAnchorEl
    }), debouncedVisible ? /*#__PURE__*/_react.default.createElement(_PopOver.PopOver, _extends({
      anchorEl: anchorEl,
      horizontalPosition: horizontalLayout,
      horizontalAlignment: horizontalLayout,
      verticalPosition: hasOverflow ? 'top' : 'bottom',
      verticalAlignment: hasOverflow ? 'bottom' : 'top'
    }, props), /*#__PURE__*/_react.default.createElement(TooltipWrapper, {
      ref: setTooltipEl
    }, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
      variant: "chip-tag-text"
    }, props.text))) : null);
  }

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.cloneElement(child, {
    ref: setAnchorEl
  }), debouncedVisible ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_PopOver.PopOver, _extends({
    anchorEl: anchorEl,
    horizontalPosition: horizontalLayout,
    horizontalAlignment: horizontalLayout,
    verticalPosition: hasOverflow ? 'top' : 'bottom',
    verticalAlignment: hasOverflow ? 'bottom' : 'top'
  }, props), /*#__PURE__*/_react.default.createElement(ExpandedTooltipWrapper, {
    ref: setTooltipEl
  }, props.extraInfo !== undefined ? /*#__PURE__*/_react.default.createElement(ExpandedTooltipTop, null, /*#__PURE__*/_react.default.createElement(ExpandedTooltipTitle, null, props.tipTitle), /*#__PURE__*/_react.default.createElement(ExpandedTooltipExtraInfo, null, props.extraInfo)) : /*#__PURE__*/_react.default.createElement(ExpandedTooltipTitle, null, props.tipTitle), props.contents)), /*#__PURE__*/_react.default.createElement(_PopOver.PopOver, {
    anchorEl: anchorEl,
    horizontalPosition: "center",
    horizontalAlignment: "center",
    verticalPosition: hasOverflow ? 'top' : 'bottom',
    verticalAlignment: hasOverflow ? 'bottom' : 'top'
  }, hasOverflow ? /*#__PURE__*/_react.default.createElement(ToolTipDownArrow, null) : /*#__PURE__*/_react.default.createElement(ToolTipUpArrow, null))) : null);
};

exports.Tooltip = Tooltip;